#include "listener.h"
#include "server.h"

//////////////////////////////////////////////////////////////////////////
// Constructor / Destructor
//////////////////////////////////////////////////////////////////////////
CListener::CListener(CServer &rServer, WORD wPort)
:m_rServer(rServer)
{
	m_bRun = FALSE;
	m_wPort = wPort;

	m_ListenSock = NULL;
	::memset(&m_ListenAddr, 0, sizeof(m_ListenAddr) );

	::memset(m_strIP, 0, sizeof(m_strIP));
	sprintf(m_strIP, "127.0.0.1");
}

CListener::~CListener()
{
	m_bRun = FALSE;

	// WSAAccept ɷֱ⶧....
	// Lintener ̱ ؼ ѹ Ѵ.
	SOCKET sock;
	SOCKADDR_IN ServerAddr;

	
	sock = ::socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	ServerAddr.sin_family = AF_INET;
	ServerAddr.sin_port = ::htons(m_wPort);
	ServerAddr.sin_addr.s_addr = ::inet_addr(m_strIP);

	::connect(sock, (SOCKADDR*)&ServerAddr, sizeof(ServerAddr));
	::closesocket(sock);

	WaitForTermination();
}


//  Ų
BOOL CListener::Listen()
{
	int nRet;

	//   
	m_ListenSock = ::WSASocket(AF_INET, SOCK_STREAM, IPPROTO_TCP, 
							NULL, 0, WSA_FLAG_OVERLAPPED);
	if (INVALID_SOCKET == m_ListenSock)
	{
		CServer::WriteLog("WSASocket Error (%d)", ::WSAGetLastError());
		return FALSE;
	}

	// 巹 Է
	m_ListenAddr.sin_family = AF_INET;
	m_ListenAddr.sin_port = ::htons(m_wPort);
	m_ListenAddr.sin_addr.S_un.S_addr = ::htonl(INADDR_ANY); 

	//  ּ ɼ 
	BOOL opt = TRUE;
	::setsockopt(m_ListenSock, SOL_SOCKET, SO_REUSEADDR, (char*)&opt, sizeof(opt));

	// bind..
	nRet = ::bind(m_ListenSock, (SOCKADDR*)&m_ListenAddr, sizeof(m_ListenAddr));
	if(nRet == SOCKET_ERROR)
	{
		CServer::WriteLog("bind Error (%d)", ::WSAGetLastError());
		return FALSE;
	}

	// listen
	nRet = ::listen(m_ListenSock, 5);
	if(nRet == SOCKET_ERROR)
	{
		CServer::WriteLog("listen ; %d error", ::WSAGetLastError());
		return FALSE;
	}

	m_bRun = TRUE;
	// 带  Ŭ̾Ʈ  óѴ.
	Start();
	return TRUE;
}

// Ŭ̾Ʈ  ó  Լ.. (峻 ȴ)
int CListener::Run()
{
	CUserContext* pUserContext = NULL;
	SOCKET hClientSock = INVALID_SOCKET;
	SOCKADDR_IN Client_SockAddr;
	int ClientLen = sizeof(Client_SockAddr);
	DWORD dwRecvBytes = 0;
	DWORD dwFlags = 0;
	int nRet;

	while (m_bRun)
	{
		// û Ŭ̾Ʈ 
		hClientSock = ::WSAAccept(m_ListenSock, 
								( SOCKADDR * )&Client_SockAddr, 
								&ClientLen, NULL, 0);
		if (SOCKET_ERROR == hClientSock)
		{	
			// Ŭ̾Ʈ н
			CServer::WriteLog("WSAAccept : %d Error", ::WSAGetLastError());
			Sleep(1000);
			if (!m_bRun)
			{
				break;
			}
			else
				continue;
		}
		else if (m_rServer.GetAcceptUser() >= MAX_USER)
		{
			CPacket packet;
			packet.command = CONNECTION;
			packet.subcode = SERVER_FULL;
			::send(hClientSock, packet.szBuffer, PACKET_HEADER_SIZE, 0);
			::closesocket(hClientSock);
			continue;
		}
		else
		{
			if (m_bRun)
			{	
				// CompletionPort Ŭ̾Ʈ  
				pUserContext = AssociateCompletionPort(hClientSock);
				if (pUserContext == NULL)
				{
					CPacket packet;
					packet.command = CONNECTION;
					packet.subcode = CONNECT_ERROR;
					::send(hClientSock, packet.szBuffer, PACKET_HEADER_SIZE, 0);
					::closesocket(hClientSock);
					continue;	
				}
				else
				{
					CPacket packet;
					packet.command = CONNECTION;
					packet.subcode = OK;
					::send(hClientSock, packet.szBuffer, PACKET_HEADER_SIZE, 0);
				}

				//  Ͽ  receiveȣ...
				nRet = ::WSARecv(hClientSock, 
							&(pUserContext->pRecvData->wsabuf), 
							1, 
							&dwRecvBytes, 
							&dwFlags, 
							&(pUserContext->pRecvData->overlapped), 
							NULL);
				if (nRet == SOCKET_ERROR && (ERROR_IO_PENDING != ::WSAGetLastError()) )
				{
					CServer::WriteLog("WSARecv Function Failed: %d", ::WSAGetLastError());
					CloseSocket(pUserContext);
					continue;
				}

				//  ϸ ť ...
				m_rServer.AcceptSocket(pUserContext);
			}
		}
	} // while
	return 0;
}


CUserContext* CListener::AssociateCompletionPort(SOCKET sock)
{
	CUserContext* pUserContext = NULL;

	pUserContext = new CUserContext(sock);

	if ( !pUserContext->isAlloc() )
	{
		FREE(pUserContext);
		return NULL;
	}

	//  (ڵ)-Ŭ̾Ʈ   迭 ε(KEY)
	//  IOCP Ѵ
	if (NULL == ::CreateIoCompletionPort((HANDLE)sock, 
									m_rServer.m_hCompletion,
									(ULONG_PTR)pUserContext, 0) )
	{
		CServer::WriteLog("CreateIoCompletionPort Error (%d)", ::GetLastError());
		CloseSocket(pUserContext);
		return NULL;
	}

	return pUserContext;
}

void CListener::CloseSocket(CUserContext* pUserContext)
{
	if (pUserContext)
	{
		::closesocket(pUserContext->Socket);
		FREE(pUserContext);
	}
}

