#include "thread.h"
/*
CThread::Exception::Exception(int num)
{
	exNum = num;
	exStr = NULL;
}

CThread::Exception::Exception(const char* str)
{
	exStr = new char[ strlen(str) +1 ];
	strcpy( exStr, str);
}

CThread::Exception::~Exception()
{
	if (exStr)
		delete [] exStr;
}
*/

//////////////////////////////////////////////////////////////////////
//  Constructor / Destructor
//////////////////////////////////////////////////////////////////////
CThread::CThread( UINT nStackSize /* =0*/,
				 UINT nPriority /* =THREAD_PRIORITY_NORMAL*/)
{
	m_hThread = NULL;
	m_nStackSize = nStackSize;
	m_nPriority = nPriority;
}

CThread::~CThread()
{
	if (NULL != m_hThread)
        WaitForTermination(0);
}


//  Ʈ Ʈ
unsigned __stdcall CThread::__THREAD_ENTRY_POINT(void* pVoid)
{
	CThread* pThis = (CThread*) pVoid;
	pThis->Run();

	::_endthreadex(0);
	return 0;
}

void CThread::Start()
{
	if (NULL == m_hThread)
	{
		m_hThread = (HANDLE) ::_beginthreadex( 0, m_nStackSize,
										CThread::__THREAD_ENTRY_POINT, 
										this, 0, (unsigned *)&m_dwThreadID);
	}
}

BOOL CThread::Stop()
{
	return WaitForTermination(0);
}

BOOL CThread::WaitForTermination(DWORD dwMilliSeconds /*= INFINITE*/)
{
	if (WAIT_OBJECT_0 != ::WaitForSingleObject(m_hThread, dwMilliSeconds))
	{
		::TerminateThread(m_hThread, 0);		
	}
	
	::CloseHandle(m_hThread);
	m_hThread = NULL;

	return TRUE;
}

void CThread::SetPriority(int nPriority)
{
	m_nPriority = nPriority;
	::SetThreadPriority( m_hThread, nPriority );
}


int CThread::GetPriority() const
{
	return ::GetThreadPriority( m_hThread );
}


/*
void CThread::processException(Exception e)
{
}
*/