#include <windows.h>
#include "dbmanager.h"
#include "server.h"

// Constructor / Destructor
CDBManager::CDBManager()
{
	m_AffectCount=-1;
	m_Ret=SQL_SUCCESS;

	// ȯ ڵ Ҵϰ  Ӽ Ѵ.
	::SQLAllocHandle(SQL_HANDLE_ENV,SQL_NULL_HANDLE, &m_hEnv);
	::SQLSetEnvAttr(m_hEnv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER)SQL_OV_ODBC3, SQL_IS_INTEGER);
}


CDBManager::~CDBManager()
{
	if (m_hStmt) SQLFreeHandle(SQL_HANDLE_STMT,m_hStmt);
	if (m_hDbc) SQLDisconnect(m_hDbc);
	if (m_hDbc) SQLFreeHandle(SQL_HANDLE_DBC,m_hDbc);
	if (m_hEnv) SQLFreeHandle(SQL_HANDLE_ENV,m_hEnv);
}

//  ҽ Ѵ.
BOOL CDBManager::Connect(char *ConStr, char *UID, char *PWD)
{
	SQLCHAR szInCon[255];
	SQLCHAR szOutCon[255];
    SQLSMALLINT nOutCon;

	int ii=1;
	SQLRETURN Ret;
	SQLINTEGER nNativeError;
	SQLCHAR szSqlState[6], szMsg[255];
	SQLSMALLINT nMsgLen;

	//  ŸԿ  MDB Ǵ SQL , Ǵ DSN Ѵ.
	::SQLAllocHandle(SQL_HANDLE_DBC, m_hEnv, &m_hDbc);

	::wsprintf((char *)szInCon,"DRIVER={Microsoft Access Driver (*.mdb)};DBQ=%s;",ConStr);
	m_Ret = ::SQLDriverConnect(m_hDbc, NULL, (SQLCHAR *)szInCon, 
							sizeof(szInCon), szOutCon,
							sizeof(szOutCon), &nOutCon, SQL_DRIVER_NOPROMPT);

	//     ش.
	if ((m_Ret != SQL_SUCCESS) && (m_Ret != SQL_SUCCESS_WITH_INFO)) 
	{
		while (Ret = ::SQLGetDiagRec(SQL_HANDLE_DBC, m_hDbc, ii, szSqlState, &nNativeError, 
									szMsg, sizeof(szMsg), &nMsgLen) != SQL_NO_DATA) 
		{
			ErrorHandler("SQLSTATE:%s, :%s",(LPCTSTR)szSqlState,(LPCTSTR)szMsg);
			ii++;
		}
		return FALSE;
	}

	//  ڵ ҴѴ.
	m_Ret = ::SQLAllocHandle(SQL_HANDLE_STMT, m_hDbc, &m_hStmt);
	if ((m_Ret != SQL_SUCCESS) && (m_Ret != SQL_SUCCESS_WITH_INFO)) 
	{
		m_hStmt = NULL;
		return FALSE;
	}
	return TRUE;
}

//  ҽ  Ѵ
void CDBManager::Disconnect()
{
	if (m_hStmt) 
	{
		::SQLFreeHandle(SQL_HANDLE_STMT, m_hStmt);
		m_hStmt = NULL;
	}
	if (m_hDbc) 
	{
		::SQLDisconnect(m_hDbc);
	}
	if (m_hDbc) 
	{
		::SQLFreeHandle(SQL_HANDLE_DBC, m_hDbc);
		m_hDbc = NULL;
	}
}

// SQL Ѵ.
BOOL CDBManager::Exec(LPCTSTR szSQL)
{
	// SQL Ѵ. SQL_NO_DATA  쵵 ϴ  Ѵ. 
	//   Fetch EOF ϵ Ǿ ֱ     ʿ .
	m_Ret = ::SQLExecDirect(m_hStmt, (SQLCHAR *)szSQL, SQL_NTS);
	if ((m_Ret != SQL_SUCCESS) && (m_Ret != SQL_SUCCESS_WITH_INFO) && (m_Ret != SQL_NO_DATA)) 
	{
		PrintDiag();
		return FALSE;
	}

	// Update, Delete, Insert ɽ  ڵ   ´.
	::SQLRowCount(m_hStmt,&m_AffectCount);

	::SQLNumResultCols(m_hStmt,&m_nCol);
	if (m_nCol > MAXCOL) 
	{
		ErrorHandler("CQuery  : ִ ÷  ʰ߽ϴ");
		return FALSE;
	}

	// m_nCol 0  Select ̿ ٸ   ̹Ƿ 
	// ε  ʿ䰡 .
	if (m_nCol == 0) {
		Clear();
		return TRUE;
	}

	//  ÷ ڿ ε ´. BindCol迭 zero base, 
	// ÷ ȣ one baseӿ  
	for (int i=0; i<m_nCol; i++) 
	{
		::SQLBindCol(m_hStmt, i+1, SQL_C_CHAR, m_BindCol[i], 255, &m_InfoCol[i]);
		::SQLDescribeCol(m_hStmt, i+1, m_ColName[i], 30, NULL, NULL, NULL, NULL, NULL);
	}
	return TRUE;
}

//   
SQLRETURN CDBManager::Fetch()
{
	m_Ret = ::SQLFetch(m_hStmt);
	return m_Ret;
}

// Ŀ    ε
void CDBManager::Clear()
{
	::SQLCloseCursor(m_hStmt);
	::SQLFreeStmt(m_hStmt, SQL_UNBIND);
}

int CDBManager::FindCol(char *name)
{
	for (int i = 0; i< m_nCol; i++) 
	{
		if (stricmp(name,(LPCTSTR)m_ColName[i])==0)
			return i+1;
	}
	return -1;
}

//  ÷ б
int CDBManager::GetInt(int nCol)
{
	if (nCol > m_nCol)
		return CQUERYNOCOL;

	if (m_InfoCol[nCol-1] == SQL_NULL_DATA) 
	{
		return CQUERYNULL;
	} 
	else 
	{
		return ::atoi(m_BindCol[nCol-1]);
	}
}

//  ÷ б
int CDBManager::GetInt(char *sCol)
{
	int n;
	n = FindCol(sCol);
	if (n==-1) 
	{
		return CQUERYNOCOL;
	} 
	else 
	{
		return GetInt(n);
	}
}

// ڿ ÷ б
void CDBManager::GetStr(int nCol, char *buf)
{
	if (nCol > m_nCol) {
		::strcpy(buf, "CQUERYNOCOL");
		return;
	}

	if (m_InfoCol[nCol-1] == SQL_NULL_DATA) 
	{
		::lstrcpy(buf,"NULL");
	} 
	else {
		::lstrcpy(buf, m_BindCol[nCol-1]);
	}
}

// ڿ ÷ б
void CDBManager::GetStr(char *sCol, char *buf)
{
	int n;

	n = FindCol(sCol);

	if (n == -1) {
		::lstrcpy(buf,"ERROR:Colume not found");
	} 
	else 
	{
		GetStr(n, buf);
	}
}

// SQL ϰ ù° ÷  
int CDBManager::ExecGetInt(LPCTSTR szSQL)
{
	int nRet;

	if ( Exec(szSQL) == FALSE) 
		return CQUERYERROR;

	// Ͱ   EOF Ѵ.
	if (Fetch() == SQL_NO_DATA) 
	{
		Clear();
		return CQUERYEOF;
	}
	nRet = GetInt(1);
	Clear();
	return nRet;
}

// SQL ϰ ù° ÷ ڿ 
void CDBManager::ExecGetStr(LPCTSTR szSQL, char *buf)
{
	// SQL   ߻  ڿ ۿ   .
	if (Exec(szSQL) == FALSE) 
	{
		::strcpy(buf, "CQUERYERROR");
		return;
	}

	// Ͱ   EOF Ѵ.
	if (Fetch() == SQL_NO_DATA) 
	{
		Clear();
		::strcpy(buf,"EOF");
		return;
	}
	GetStr(1,buf);
	Clear();
}

//   
void CDBManager::PrintDiag()
{
	int ii;
	SQLRETURN Ret;
	SQLINTEGER nNativeError;
	SQLCHAR szSqlState[6], szMsg[255];
	SQLSMALLINT nMsgLen;

	ii=1;
	
	Ret = SQLGetDiagRec(SQL_HANDLE_STMT, m_hStmt, ii, szSqlState, &nNativeError, 
						szMsg, sizeof(szMsg), &nMsgLen);

	while (Ret != SQL_NO_DATA) 
	{
		ErrorHandler("SQLSTATE:%s, :%s",(LPCTSTR)szSqlState,(LPCTSTR)szMsg);
		ii++;
	}
}

void CDBManager::ErrorHandler(const char* err, ...)
{
	char buf[1024];
	va_list ap;

	va_start(ap, err); //  .
	::vsprintf(buf, err, ap);

	// ó..
//	std::cout << buf << std::endl;
	CServer::WriteLog(buf);
	
	va_end(ap); //  볡..
}