#ifndef __SERVER_H_CSH__
#define __SERVER_H_CSH__

#pragma once

#include <iostream>
#include <winsock2.h>
#include <deque>
#include <map>
#include "usercontext.h"
#include "dbmanager.h"
#include "share.h"


#define CONNECTION_PATH "metop.mdb"
#define MAX_USER 10000

const char VERSION[] = "Metop.ver.1.0";

class CListener;
class CWorker;

// Ŭ ϱ WSAStartup()
// α׷ ϱ WSACleanup()  ʿϴ
/**	..
	WSADATA wsaData;
	WSAStartup(MAKEWORD(2,2), &wsaData);

	.. CServer ..

	WSACleanup();
**/
class CServer
{
public:
	CServer(const WORD nPort);		// Constructor
	virtual ~CServer();				// Destructor

private:
	CListener* m_pListener;		// 
	WORD m_wPort;				// Ʈ
	DWORD m_dwThreadCount;		// ǰִ Worker  (Listener X)

	CRITICAL_SECTION m_csSocket;				//  ť ũƼ 
	std::deque<CUserContext*> m_deqSocket;		//  
	CRITICAL_SECTION m_csLoggedOn;
	std::map<DWORD, CUserContext*> m_mapLoggedOn;
	std::deque<CWorker*> m_deqWorker; // worker thread

public:
	HANDLE m_hCompletion;		// øƮ ڵ
	CDBManager* m_pDb;

public:
	BOOL Start();				//  

	// ӵ ڸƮ(deque) , 
	void AcceptSocket(CUserContext* lpCompletionKey);
	void DeleteSocket(CUserContext* lpCompletionKey);

	// α׿µ ڸƮ(map) , 
	void AcceptLoggedOnUser(DWORD uniqueid, CUserContext* lpCompletionKey);
	void DeleteLoggedOnUser(DWORD uniqueid);
	// α׿µ  ˻
	BOOL isLoggedOn(DWORD uniqueid);
	// α׿µ  ؽƮ
	CUserContext* GetLoggedOnUserContext(DWORD uniqueid);

	// ӵȻ 
	size_t GetAcceptUser();
	// α׿µ   
	size_t GetLogOnUser();

	// ޽  ¸ αȭ, ȭ鿡 
	static void WriteLog(const char* strErr, ...);
};

#endif // #ifndef __SERVER_H_CSH__