#include "packet.h"
#include "usercontext.h"


CUserContext::CUserContext(SOCKET sock)
:Socket(sock), bCloseSocket(FALSE)
{

	pSendData = new PER_IO_DATA;
	if (pSendData)
	{
		pSendData->nNum = 0;
		InitSendData();
		pSendData->pSumData = NULL;
		pSendData->SumDataLen = 0;
		pSendData->PacketNum = 0;
	}

	pRecvData = new PER_IO_DATA;
	if (pRecvData)
	{
		pRecvData->nNum = 0;
		InitRecvData();
		pRecvData->pSumData = NULL;
		pRecvData->SumDataLen = 0;
		pRecvData->PacketNum = 0;

	}
}

CUserContext::CUserContext(const CUserContext &context)
: Socket(context.Socket)
{
	pSendData->SumDataLen = context.pSendData->SumDataLen;
	pSendData->PacketNum = context.pSendData->PacketNum;
	pRecvData->SumDataLen = context.pRecvData->SumDataLen;
	pRecvData->PacketNum = context.pRecvData->PacketNum;

	if (context.pRecvData)
	{
		pRecvData = new PER_IO_DATA;
		::memcpy( pRecvData, context.pRecvData, sizeof(PER_IO_DATA) );
		if (pRecvData->SumDataLen)
		{
			pRecvData->pSumData = new char[pRecvData->SumDataLen+1];
			::memcpy( pRecvData->pSumData, context.pRecvData->pSumData, pRecvData->SumDataLen);
		}

	}

	if (context.pSendData)
	{
		pSendData = new PER_IO_DATA;
		::memcpy( pSendData, context.pSendData, sizeof(PER_IO_DATA) );
		if (pSendData->SumDataLen)
		{
			pSendData->pSumData = new char [pSendData->pSumData+1];
			::memcpy(pSendData->pSumData, context.pSendData->pSumData, pSendData->SumDataLen);
		}
	}

}

CUserContext::~CUserContext()
{
	FREE(pSendData->pSumData);
	FREE(pRecvData->pSumData);
	FREE(pSendData);
	FREE(pRecvData);
}

BOOL CUserContext::isAlloc()
{
	if ( pRecvData == NULL || pSendData == NULL)
	{
		return FALSE;
	}

	return TRUE;
}

void CUserContext::InitRecvData()
{
	::memset(&pRecvData->overlapped, 0, sizeof(OVERLAPPED));
	::memset(pRecvData->packet.szBuffer, 0, sizeof(BUFFER_SIZE) );
	pRecvData->nTotalBytes = 0;
	pRecvData->nCurBytes = 0;
	pRecvData->wsabuf.buf = pRecvData->packet.szBuffer;
	pRecvData->wsabuf.len = BUFFER_SIZE;
}

void CUserContext::InitSendData()
{
	::memset(&pSendData->overlapped, 0, sizeof(OVERLAPPED));
	::memset(pSendData->packet.szBuffer, 0, sizeof(BUFFER_SIZE) );
	pSendData->nTotalBytes = 0;
	pSendData->nCurBytes = 0;
	pSendData->wsabuf.buf = pSendData->packet.szBuffer;
	pSendData->wsabuf.len = 0;
}

void CUserContext::UpdateSendData(WORD comm, WORD subcomm, const char* data /* =NULL*/, WORD len /* =0*/, char type /* = 0*/)
{
	pSendData->nNum ++;
	pSendData->packet.id = pSendData->nNum;
	pSendData->packet.uniqueid = nUniqueid;
	pSendData->packet.command = comm;
	pSendData->packet.subcode = subcomm;
	pSendData->packet.type = type;

	if (len)
	{
		::memcpy(pSendData->packet.data, data, len);
	}
	pSendData->packet.length = len;

	pSendData->nTotalBytes = len + PACKET_HEADER_SIZE;
	pSendData->wsabuf.len = len + PACKET_HEADER_SIZE;
}